#include "StdAfx.h"
#include "MusicTrack.h"

//==============================================================
//		RXgN^
//--------------------------------------------------------------
//	
//		MMLfile*	MML
//	Ԓl
//					
//==============================================================
MusicTrack::MusicTrack(const char _strName[]):
	MusicItem(_strName),
	offset_now(0),				//
	offset_loop(0),				//[v
	offset_repeat_a_s(0),		//s[g`
	offset_repeat_a_b(0),		//s[g`
	offset_repeat_b_s(0),		//s[ga
	offset_repeat_b_b(0),		//s[ga
	DefaultLength(24),
	loop_flag(false)
{
	//
	KeySignature[0]	= 0;
	KeySignature[1]	= 0;
	KeySignature[2]	= 0;
	KeySignature[3]	= 0;
	KeySignature[4]	= 0;
	KeySignature[5]	= 0;
	KeySignature[6]	= 0;
	KeySignature[7]	= 0;
}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
MusicTrack::~MusicTrack(void)
{
}

//==============================================================
//		
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
void	MusicTrack::SetLoop()
{
	offset_loop = offset_now;
	loop_flag	= true;
}

//==============================================================
//		
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//				
//==============================================================
void	MusicTrack::SetRepeat_A_Start(MMLfile* MML)
{
	SetEvent(new mml_general(nsd_Repeat_A_Start, MML, "Repeat(A) Start"));
	offset_repeat_a_s = offset_now;	// ] R}hł́ÃR}hɖ߂B
	offset_repeat_a_b = 0;
}

//==============================================================
//		
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//				
//==============================================================
void	MusicTrack::SetRepeat_A_Branch(MMLfile* MML)
{
	if(offset_repeat_a_s != 0){
		if(offset_repeat_a_b == 0){
			offset_repeat_a_b = offset_now + 1;	//̈ʒu
			_old_repeatA_Branch = new mml_Address(nsd_Repeat_A_Branch, "Repeat(A) Branch");
			SetEvent(_old_repeatA_Branch);
		} else {
			MML->Err("s[g(A) : R}hdĂ܂B");
		}
	} else {
		MML->Err("s[g(A)̊Jn [ R}h܂B");
	}
}

//==============================================================
//		
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//				
//==============================================================
void	MusicTrack::SetRepeat_A_End(MMLfile* MML)
{
	mml_Address*	_event;

	if(offset_repeat_a_s != 0){
		_event = new mml_Address(nsd_Repeat_A_End, "Repeat(A) End");
		_event->set_Address(offset_repeat_a_s - offset_now - 1);
		SetEvent(_event);
		//򂪂B
		if(offset_repeat_a_b != 0){
			_old_repeatA_Branch->set_Address(offset_now - offset_repeat_a_b);
		}
		offset_repeat_a_s = 0;
	} else {
		MML->Err("s[g(A)̊Jn [ R}h܂B");
	}

}

//==============================================================
//		
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//				
//==============================================================
void	MusicTrack::SetRepeat_B_Start(MMLfile* MML)
{
	SetEvent(new mml_general(nsd_Repeat_B_Start, "Repeat(B) Start"));
	offset_repeat_b_s = offset_now;	// :| R}hł́ÃR}hɖ߂B
	offset_repeat_b_b = 0;
}

//==============================================================
//		
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//				
//==============================================================
void	MusicTrack::SetRepeat_B_Branch(MMLfile* MML)
{
	if(offset_repeat_b_s != 0){
		if(offset_repeat_b_b == 0){
			offset_repeat_b_b = offset_now;	//R}hB
			SetEvent(new mml_general(nsd_Repeat_B_Branch, "Repeat(B) Branch"));
		} else {
			MML->Err("s[g(B) \\ R}hdĂ܂B");
		}
	} else {
		MML->Err("s[g(B)̊Jn |: R}h܂B");
	}
}

//==============================================================
//		
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//				
//==============================================================
void	MusicTrack::SetRepeat_B_End(MMLfile* MML)
{
	mml_Address*	_event;

	if(offset_repeat_b_s != 0){
		if(offset_repeat_b_b != 0){
			if(offset_repeat_b_s < offset_repeat_a_s){
				MML->Err("s[g(A)̋Ԃ̓rłB");
			}
			_event = new mml_Address(nsd_Repeat_B_End, "Repeat(B) End");
			_event->set_Address(offset_repeat_b_s - offset_now - 1);
			SetEvent(_event);
		} else {
			MML->Err("s[g(B) \\ R}h܂łBK_ \\ ͎w肵ĂB");
		}
	} else {
		MML->Err("s[g(B)̊Jn |: R}h܂B");
	}
}

//==============================================================
//		
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//				
//==============================================================
void	MusicTrack::SetEnvelop(unsigned char _opcode, MMLfile* MML)
{
	mml_Address*		_event = new mml_Address(_opcode, "Envelop");
	unsigned	int		_no = MML->GetInt();

	_event->set_id(_no);
	SetEvent(_event);
	ptcEnvelop.push_back(_event);
}

//==============================================================
//		
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//				
//==============================================================
void	MusicTrack::SetVRC7(MMLfile* MML)
{
	mml_Address*		_event = new mml_Address(nsc_VRC7, "VRC7 user instruments");
	unsigned	int		_no = MML->GetInt();

	_event->set_id(_no);
	SetEvent(_event);
	ptcOPLL.push_back(_event);
}
//==============================================================
//		
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//				
//==============================================================
void	MusicTrack::SetN163(MMLfile* MML)
{
	unsigned	char	cData;
	mml_Address*		_event = new mml_Address(nsc_N163,MML->GetInt(),"n163 wave table");

	cData = MML->GetChar();
	if(cData != ','){
		MML->Err("@N R}h̃p[^܂BQw肵ĂB");
	}

	_event->set_id(MML->GetInt());
	SetEvent(_event);
	ptcWave.push_back(_event);
}
//==============================================================
//		
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//				
//==============================================================
void	MusicTrack::SetN163Channel(MMLfile* MML)
{
	int	i = MML->GetInt();

	if( (i <= 8) && (i >=1) ){
		SetEvent(new mml_general(nsc_N163_Channel,i-1,"n163 channel"));
	} else {
		MML->Err("n163̃`l1`8͈̔͂Ŏw肵ĂB");
	}


}
//==============================================================
//		
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//				
//==============================================================
void	MusicTrack::SetSubroutine(MMLfile* MML)
{
	mml_Address*		_event = new mml_Address(nsd_Call, "Subroutine");
	unsigned	int		_no = MML->GetInt();

	_event->set_id(_no);
	SetEvent(_event);
	ptcSubroutine.push_back(_event);
}

//==============================================================
//		AhX肷B
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
void	MusicTrack::Fix_Address(MusicFile* MUS)
{
	//----------------------
	//Localϐ
	vector<	mml_Address*	>::iterator	itSub;
	vector<	mml_Address*	>::iterator	itEnv;
	vector<	mml_Address*	>::iterator	itVRC7;
	vector<	mml_Address*	>::iterator	itN163;
	unsigned	int	_no;
	unsigned	int	_sub_offset;
	unsigned	int	_com_offset;

	//----------------------
	//
	if(!ptcSubroutine.empty()){
		itSub = ptcSubroutine.begin();
		while(itSub != ptcSubroutine.end()){
			_no			= (*itSub)->get_id();		//Tu[`No.̎擾
			_com_offset	= (*itSub)->getOffset();
			if( MUS->ptcSub.count(_no) == 0){
				printf("Tu[` %d Ԃ݂܂B",_no);
				exit(-1);
			}
			_sub_offset = MUS->ptcSub[_no]->getOffset();	//wTu[`݂ItZbg
			(*itSub)->set_Address(_sub_offset - _com_offset - 1);
			itSub++;
		}
	}

	//
	if(!ptcEnvelop.empty()){
		itEnv = ptcEnvelop.begin();
		while(itEnv != ptcEnvelop.end()){
			_no			= (*itEnv)->get_id();		//Gx[vNo.̎擾
			_com_offset	= (*itEnv)->getOffset();
			if( MUS->ptcEnv.count(_no) == 0){
				printf("Gx[v %d Ԃ݂܂B",_no);
				exit(-1);
			}
			_sub_offset = MUS->ptcEnv[_no]->getOffset();	//wGx[v݂ItZbg
			(*itEnv)->set_Address(_sub_offset - _com_offset - 1);
			itEnv++;
		}
	}

	//
	if(!ptcOPLL.empty()){
		itVRC7 = ptcOPLL.begin();
		while(itVRC7 != ptcOPLL.end()){
			_no			= (*itVRC7)->get_id();		//Gx[vNo.̎擾
			_com_offset	= (*itVRC7)->getOffset();
			if( MUS->ptcVRC7.count(_no) == 0){
				printf("VRC7 %d Ԃ݂܂B",_no);
				exit(-1);
			}
			_sub_offset = MUS->ptcVRC7[_no]->getOffset();	//wGx[v݂ItZbg
			(*itVRC7)->set_Address(_sub_offset - _com_offset - 1);
			itVRC7++;
		}
	}

	//
	if(!ptcWave.empty()){
		itN163 = ptcWave.begin();
		while(itN163 != ptcWave.end()){
			_no			= (*itN163)->get_id();		//Gx[vNo.̎擾
			_com_offset	= (*itN163)->getOffset();
			if( MUS->ptcN163.count(_no) == 0){
				printf("N163 %d Ԃ݂܂B",_no);
				exit(-1);
			}
			_sub_offset = MUS->ptcN163[_no]->getOffset();	//wGx[v݂ItZbg
			(*itN163)->set_Address(_sub_offset - _com_offset - 2);
			itN163++;
		}
	}

}
//==============================================================
//		̃Cxg쐬
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//		int			note	m[gi0:C 1:D 2:E c 7:Bj
//	Ԓl
//				
//==============================================================
void	MusicTrack::SetNote(MMLfile*	MML,int note)
{
	unsigned		char	cData;
	static	const	char	note_code[]={0,2,4,5,7,9,11};
					int		_key = note_code[note];
	unsigned		int		Length = -1;
	unsigned		int		GateTime = -1;
					bool	Slur = false;

	//ՎL
	cData = MML->GetChar();
	//If Natural then skip
	if((cData != '=') && (cData != '*')){
		_key += KeySignature[note];
		while((cData == '#') || (cData == '+') || (cData == '-')){
			switch(cData){
				case('#'):
				case('+'):
					_key++;
					break;
				case('-'):
					_key--;
					break;
				default:
					break;
			}
			cData = MML->GetChar();	//̕
		}
		//ՎLł͂ȂȂ̂ŁA|C^߂B
		MML->Back();
	}

	cData = MML->GetChar();
	if(((cData >= '0') && (cData <= '9')) || (cData == '%') || (cData == '.')){
		MML->Back();
		Length = MML->GetLength(DefaultLength);
	} else {
		MML->Back();
	}

	cData = MML->GetChar();
	if(cData == ','){
		cData = MML->GetChar();
		if(cData == '0'){
			GateTime = 0;
		} else {
			MML->Back();
			GateTime = MML->GetLength(DefaultLength);
		}
	} else if(cData == '&') {
		Slur = true;
	} else {
		MML->Back();
	}

	//wł͈͂𒴂ꍇB
	while(_key < 0){
		_key += 12;
		SetEvent(new mml_general(nsd_Octave_Down_1, "One time octave down"));
	}

	while(_key >= 12){
		_key -= 12;
		SetEvent(new mml_general(nsd_Octave_Up_1, "One time octave up"));
	}


	//CxgIuWFNg̍쐬
	_old_note = new mml_note(_key, Length, GateTime, Slur, "Note");
	SetEvent(_old_note);
}

//==============================================================
//		x̃Cxg쐬
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//				
//==============================================================
void	MusicTrack::SetRest(MMLfile*	MML)
{
	unsigned		char	cData;
	unsigned		char	_code = 0x0F;
	unsigned		int		Length = -1;
	unsigned		int		GateTime = -1;
					bool	Slur = false;

	//x̃[h
	cData = MML->GetChar();
	switch(cData){
		case('-'):
			_code = 0x0D;
			break;
		case('#'):
		case('+'):
			_code = 0x0E;
			break;
		case('='):
		case('*'):
			_code = 0x0F;
			break;
		default:
			MML->Back();
			switch(KeySignature[7]){
				case(-1):
					_code = 0x0D;
					break;
				case(+1):
					_code = 0x0E;
					break;
				default:
					_code = 0x0F;
					break;
			}
			break;
	}

	//
	cData = MML->GetChar();
	if(((cData >= '0') && (cData <= '9')) || (cData == '%') || (cData == '.')){
		MML->Back();
		Length = MML->GetLength(DefaultLength);
	} else {
		MML->Back();
	}

	//Q[g^C or ^C
	cData = MML->GetChar();
	if(cData == ','){
		cData = MML->GetChar();
		if(cData == '0'){
			GateTime = 0;
		} else {
			MML->Back();
			GateTime = MML->GetLength(DefaultLength);
		}
	} else if(cData == '&') {
		Slur = true;
	} else {
		MML->Back();
	}

	_old_note = new mml_note(_code, Length, GateTime, Slur, "Rest");
	SetEvent(_old_note);
}

//==============================================================
//		^C̃IuWFNg쐬ixōj
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	MusicTrack::SetTai(MMLfile* MML)
{
	_old_note->SetTai();
	SetRest(MML);
}

//==============================================================
//		ȗ̉
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	MusicTrack::SetLength(MMLfile* MML)
{
	DefaultLength = MML->GetLength(DefaultLength);
	mml_general*	_event;

	switch(DefaultLength){
		case(96):
			_event = new mml_general(nsd_Length_96, "Length 96");
			break;
		case(72):
			_event = new mml_general(nsd_Length_72, "Length 72");
			break;
		case(48):
			_event = new mml_general(nsd_Length_48, "Length 48");
			break;
		case(36):
			_event = new mml_general(nsd_Length_36, "Length 36");
			break;
		case(32):
			_event = new mml_general(nsd_Length_32, "Length 32");
			break;
		case(24):
			_event = new mml_general(nsd_Length_24, "Length 24");
			break;
		case(18):
			_event = new mml_general(nsd_Length_18, "Length 18");
			break;
		case(16):
			_event = new mml_general(nsd_Length_16, "Length 16");
			break;
		case(12):
			_event = new mml_general(nsd_Length_12, "Length 12");
			break;
		case(9):
			_event = new mml_general(nsd_Length_9,  "Length 9");
			break;
		case(8):
			_event = new mml_general(nsd_Length_8,  "Length 8");
			break;
		case(6):
			_event = new mml_general(nsd_Length_6,  "Length 6");
			break;
		case(4):
			_event = new mml_general(nsd_Length_4,  "Length 4");
			break;
		case(3):
			_event = new mml_general(nsd_Length_3,  "Length 3");
			break;
		case(2):
			_event = new mml_general(nsd_Length_2,  "Length 2");
			break;
		case(1):
			_event = new mml_general(nsd_Length_1,  "Length 1");
			break;
		default:
			_event = new mml_general(nsd_Length, (DefaultLength & 0xFF), "Length");
			break;
	}
	SetEvent(_event);
}

//==============================================================
//		IN^[u
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	MusicTrack::SetOctave(MMLfile* MML)
{
	unsigned	int	iOctave = MML->GetInt();

	if( (iOctave <= 9) && (iOctave >=2) ){
		SetEvent(new mml_general(nsd_Octave + iOctave - 2, "Octave"));
	} else {
		MML->Err("IN^[u2`9͈̔͂Ŏw肵ĂBo1̗̈́A΃IN^[upB");
	}
}

//==============================================================
//		Q[g^C(q)
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	MusicTrack::SetGatetime(MMLfile* MML)
{
	unsigned	int	i = MML->GetInt();

	if( (i <= 15) && (i >= 0) ){
		SetEvent(new mml_general(nsd_GateTime_Byte + i, "Gatetime(q) Byte"));
	} else if( i <= 255) {
		SetEvent(new mml_general(nsd_GateTime_q, i, "Gatetime(q)"));
	} else {
		MML->Err("p[^̒l͈͂z܂B");
	}
}

//==============================================================
//		Q[g^C(u)
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	MusicTrack::SetGatetime_u(MMLfile* MML)
{
	unsigned		int	i;
	unsigned		char	cData;

	//x̃[h
	cData = MML->GetChar();
	if(cData == '0'){
		i = 0;
	} else {
		MML->Back();
		i = MML->GetLength(DefaultLength);
	}
	SetEvent(new mml_general(nsd_GateTime_u, i & 0xFF , "GateTime(u)"));
	
}

//==============================================================
//		XC[v
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	MusicTrack::SetSweep(MMLfile* MML)
{
				int		iSpeed;
				int		iDepth;
	unsigned	char	_data;
	unsigned	char	cData;

	iSpeed = MML->GetInt();

	cData = MML->GetChar();
	if(cData != ','){
		if( (iSpeed < 0) || (iSpeed > 255) ){
			MML->Err("0`255͈̔͂Ŏw肵ĂB");
		}
		MML->Back();
		_data = iSpeed;
	} else {
		if( (iSpeed < 0) || (iSpeed > 15) ){
			MML->Err("XC[vŎwł͈͂𒴂Ă܂B0`15͈̔͂Ŏw肵ĂB");
		}
		iDepth = MML->GetInt();
		if( (iDepth < 0) || (iDepth > 15) ){
			MML->Err("XC[vŎwł͈͂𒴂Ă܂B0`15͈̔͂Ŏw肵ĂB");
		}
		_data = ((iSpeed & 0x0F) << 4) | (iDepth & 0x0F);
	}

	SetEvent(new mml_general(nsd_Sweep, _data, "Sweep"));
}

//==============================================================
//		
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	MusicTrack::SetVolume(MMLfile* MML)
{
	unsigned	int	i = MML->GetInt();

	if( (i <= 15) && (i >= 0) ){
		SetEvent(new mml_general(nsd_Volume + i, "Volume"));
	} else {
		MML->Err("ʂŎwł͈͂𒴂Ă܂B0`15͈̔͂Ŏw肵ĂB");
	}
}

//==============================================================
//		[X[h
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	MusicTrack::SetReleaseMode(MMLfile* MML)
{
	unsigned	int	i = MML->GetInt();
	mml_general*	_event;

	switch(i){
		case(0):
			_event = new mml_general(nsd_GateMode_0,  "GateMode 0");
			break;
		case(1):
			_event = new mml_general(nsd_GateMode_1,  "GateMode 1");
			break;
		case(2):
			_event = new mml_general(nsd_GateMode_2,  "GateMode 2");
			break;
		default:
			MML->Err("[X[hŎwł͈͂𒴂Ă܂B0`2͈̔͂Ŏw肵ĂB");
			break;
	}
	SetEvent(_event);
}

//==============================================================
//		[XF
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	MusicTrack::SetReleaseVoice(MMLfile* MML)
{
	unsigned	int	i = MML->GetInt();

	if( (i <= 7) && (i >= 0) ){
		SetEvent(new mml_general(nsd_Release_Voice + i, "Release Voice"));
	} else {
		MML->Err("[XFŎwł͈͂𒴂Ă܂B0`7͈̔͂Ŏw肵ĂB");
	}
}

//==============================================================
//		[X
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	MusicTrack::SetReleaseVolume(MMLfile* MML)
{
	unsigned	int	i = MML->GetInt();

	if( (i <= 15) && (i >= 0) ){
		SetEvent(new mml_general(nsd_Release_Volume + i, "Release Volume"));
	} else {
		MML->Err("ʂŎwł͈͂𒴂Ă܂B0`15͈̔͂Ŏw肵ĂB");
	}
}

//==============================================================
//		
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	MusicTrack::SetProtament(MMLfile* MML)
{
	unsigned	char	cData;

				int		_Decay;
				int		_Rate;
				int		_Depth;
				int		_Target;

	_Decay = MML->GetInt();
	if( (_Decay < 0) || (_Decay > 255) ){
		MML->Err("|^g̑1p[^́A0`255͈̔͂Ŏw肵ĂB");
	}
	_Decay++;

	cData = MML->GetChar();
	if(cData != ','){
		MML->Err("P R}h̃p[^܂BSw肵ĂB");
	}

	_Rate = MML->GetInt();
	if( (_Rate < 1) || (_Rate > 256) ){
		MML->Err("|^g̑2p[^́A1`256͈̔͂Ŏw肵ĂB");
	}

	cData = MML->GetChar();
	if(cData != ','){
		MML->Err("P R}h̃p[^܂BSw肵ĂB");
	}

	_Depth = MML->GetInt();
	if( (_Depth < -128) || (_Depth > 127) ){
		MML->Err("|^g̑3p[^́A-128`127͈̔͂Ŏw肵ĂB");
	}
	_Decay++;

	cData = MML->GetChar();
	if(cData != ','){
		MML->Err("P R}h̃p[^܂BSw肵ĂB");
	}

	_Target = MML->GetInt();
	if( (_Target < -128) || (_Target > 127) ){
		MML->Err("|^g̑4p[^́A-128`127͈̔͂Ŏw肵ĂB");
	}
	SetEvent(new mml_general(nsd_Portamento, _Decay & 0xFF,_Rate & 0xFF,_Depth & 0xFF,_Target & 0xFF, "Portamento"));
}

//==============================================================
//		
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	MusicTrack::SetVRC7_Write(MMLfile* MML)
{
	unsigned	char	cData;

				int		_Reg;
				int		_Dat;

	_Reg = MML->GetInt();
	if( (_Reg < 0) || (_Reg > 0x40) ){
		MML->Err("|^g̑1p[^́A0`63͈̔͂Ŏw肵ĂB");
	}

	cData = MML->GetChar();
	if(cData != ','){
		MML->Err("P R}h̃p[^܂BSw肵ĂB");
	}

	_Dat = MML->GetInt();
	if( (_Dat < 0) || (_Dat > 255) ){
		MML->Err("|^g̑2p[^́A0`255͈̔͂Ŏw肵ĂB");
	}

	SetEvent(new mml_general(nsc_VRC7_reg,_Reg,_Dat, "VRC7 Register Write"));
}
//==============================================================
//		
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	MusicTrack::SetPoke(MMLfile* MML)
{
	unsigned	int	addr;
	unsigned	int	data;
	unsigned	char	cData;

	addr = MML->GetInt();
	if( (addr < 0x0000) || (addr > 0xFFFF) ){
		MML->Err("p[^̒l͈͂z܂B");
	}

	cData = MML->GetChar();
	if(cData != ','){
		MML->Err("y R}h̃p[^܂BQw肵ĂB");
	}

	data = MML->GetInt();
	if(data > 255){
		MML->Err("p[^̒l͈͂z܂B");
	}
	SetEvent(new mml_poke(addr, data & 0xFF));
}

//==============================================================
//		̐ݒ
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//		
//==============================================================
void	MusicTrack::SetKeySignature(MMLfile*	MML)
{
	//R}hID
	enum	KeySignature_ID {
		ks_Sharp,
		ks_Flat,
		ks_Natural,
		ks_c,
		ks_d,
		ks_e,
		ks_f,
		ks_g,
		ks_a,
		ks_b,
		ks_r,
		ks_0,
		ks_s1,
		ks_s2,
		ks_s3,
		ks_s4,
		ks_s5,
		ks_s6,
		ks_s7,
		ks_f1,
		ks_f2,
		ks_f3,
		ks_f4,
		ks_f5,
		ks_f6,
		ks_f7
	};

	//R}h̒`
	static	const	Command_Info	KS_Command[] = {
		{	"+",		ks_Sharp	},
		{	"#",		ks_Sharp	},
		{	"-",		ks_Flat		},
		{	"=",		ks_Natural	},
		{	"*",		ks_Natural	},
		{	"c",		ks_c		},
		{	"d",		ks_d		},
		{	"e",		ks_e		},
		{	"f",		ks_f		},
		{	"g",		ks_g		},
		{	"a",		ks_a		},
		{	"b",		ks_b		},
		{	"r",		ks_r		},
		{	"C_Dur",	ks_0		},	//
		{	"Cis_Dur",	ks_f5		},	//bbbbb
		{	"D_Dur",	ks_s2		},	//##
		{	"Dis_Dur",	ks_f3		},	//bbb
		{	"E_Dur",	ks_s4		},	//####
		{	"F_Dur",	ks_f1		},	//b
		{	"Fis_Dur",	ks_s6		},	//######
		{	"Gs_Dur",	ks_f6		},	//bbbbbb
		{	"G_Dur",	ks_s1		},	//#
		{	"As_Dur",	ks_f4		},	//bbbb
		{	"A_Dur",	ks_s3		},	//###
		{	"B_Dur",	ks_f2		},	//bb
		{	"H_Dur",	ks_s5		}	//#####
	};

	unsigned	char	cData;
				char	sign = 0;

	while(MML->cRead() != '{'){
		if(MML->eof()){
			MML->Err("R}hEubN̊Jn{܂B");
		}
	}

	// } ܂ŁALqubNRpCB
	while((cData = MML->GetChar()) != '}'){
		
		// } OɁA[EOF]G[
		if( MML->eof() ){
			MML->Err("R}hEubN̏I[`}'܂B");
		}

		//P߂
		MML->StreamPointerAdd(-1);

		switch(MML->GetCommandID(KS_Command, sizeof(KS_Command)/sizeof(Command_Info))){
			case(ks_c):
				KeySignature[0] = sign;
				break;
			case(ks_d):
				KeySignature[1] = sign;
				break;
			case(ks_e):
				KeySignature[2] = sign;
				break;
			case(ks_f):
				KeySignature[3] = sign;
				break;
			case(ks_g):
				KeySignature[4] = sign;
				break;
			case(ks_a):
				KeySignature[5] = sign;
				break;
			case(ks_b):
				KeySignature[6] = sign;
				break;
			case(ks_r):
				KeySignature[7] = sign;
				break;
			case(ks_Natural):
				sign = 0;
				break;
			case(ks_Sharp):
				sign = 1;
				break;
			case(ks_Flat):
				sign = -1;
				break;
			default:
				MML->Err(" K{} R}ḧŖm̕w肳܂B");
				break;
		}
	}

	//for Debug
/*
	cout << "[0] c = " << (int)KeySignature[0] << endl;
	cout << "[1] d = " << (int)KeySignature[1] << endl;
	cout << "[2] e = " << (int)KeySignature[2] << endl;
	cout << "[3] f = " << (int)KeySignature[3] << endl;
	cout << "[4] g = " << (int)KeySignature[4] << endl;
	cout << "[5] a = " << (int)KeySignature[5] << endl;
	cout << "[6] b = " << (int)KeySignature[6] << endl;
*/
}

//==============================================================
//		LqubN̏IiEnd of Track̒ǉj
//--------------------------------------------------------------
//	
//		
//	Ԓl
//		
//==============================================================
size_t	MusicTrack::SetEnd(void)
{
	mml_Address*	_event;

	if(loop_flag == false){
		SetEvent(new mml_general(nsd_EndOfTrack,"End of Track"));
	} else {
		_event = new mml_Address(nsd_Jump, "End of Track with LOOP");
		_event->set_Address(offset_loop - offset_now - 1);
		SetEvent(_event);
	}
	iSize = offset_now;

	return(iSize);
}

//==============================================================
//		V[PXEIuWFNg̒ǉ
//--------------------------------------------------------------
//	
//		MusicItem* _item	V[PXEIuWFNg
//	Ԓl
//		
//==============================================================
void	MusicTrack::SetEvent(MusicItem* _item)
{
	//TCY̕AItZbg𑝂₷B
	offset_now += (unsigned int)_item->getSize();

	//object̃|C^ۑĂB
	ptcItem.push_back(_item);
}

